unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdHTTP, ComCtrls, OleCtrls, SHDocVw, ExtCtrls;

type
  TfrmMain = class(TForm)
    lblServer: TLabel;
    edtServer: TEdit;
    lblPort: TLabel;
    spePort: TSpinEdit;
    mmbResult: TMemo;
    HTTP: TIdHTTP;
    chbActive: TCheckBox;
    btnStanice: TButton;
    stbStatus: TStatusBar;
    btnSpojeni: TButton;
    lblOdkud: TLabel;
    edtOdkud: TEdit;
    lblKam: TLabel;
    edtKam: TEdit;
    lblPres: TLabel;
    edtPres: TEdit;
    lblOdjezd: TLabel;
    speHodin: TSpinEdit;
    speMinut: TSpinEdit;
    lblHodin: TLabel;
    lblMinut: TLabel;
    lblPrestupy: TLabel;
    spePrestupy: TSpinEdit;
    lblSpojeni: TLabel;
    speSpojeni: TSpinEdit;
    lblNeboDele: TLabel;
    wbResult: TWebBrowser;
    procedure chbActiveClick(Sender: TObject);
    procedure btnStaniceClick(Sender: TObject);
    procedure edtServerChange(Sender: TObject);
    procedure spePortChange(Sender: TObject);
    procedure btnSpojeniClick(Sender: TObject);
    function vyrid_chyby(Response:string):string;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.chbActiveClick(Sender: TObject);   //pro (de)aktivaci HTTP Klienta
begin
  if HTTP.Connected then begin
    HTTP.Disconnect;
    exit;
  end;
  try
    HTTP.Connect;
  except
    Application.MessageBox('Nelze spustit HTTP klient zkontrolujte nastaveni !!!','ERROR !!!', MB_OK+MB_ICONERROR);
    chbActive.Checked:=false;
  end;
end;

function TfrmMain.vyrid_chyby(Response:string):string;  //pro zformatovani chybove zpravy
var p:integer;
begin
  p:=pos('<Chyba>',Response);
  while p<>0 do begin
    delete(Response,p,length('<Chyba>'));
    p:=pos('<Chyba>',Response);
  end;
  stbStatus.Panels[0].Text:='Zpracovavam data... (3/3)';
  p:=pos('</Chyba>',Response);
  while p<>0 do begin
    delete(Response,p,length('</Chyba>'));
    p:=pos('</Chyba>',Response);
  end;
  result:=Response;
end;

procedure TfrmMain.btnStaniceClick(Sender: TObject);      //pro zobrazeni dostupnych stanic (/SeznamStanic)
var Response:String;
    p:integer;
begin
  mmbResult.Lines.Clear;
  mmbResult.Hide;             //"pehodm" komponenty
  wbResult.Hide;
  stbStatus.Panels[0].Text:='Nacitam data ze serveru...';
  try
    Response:=HTTP.Get('/SeznamStanic');
  except
    Application.MessageBox('Nelze spustit HTTP klient zkontrolujte nastaveni !!!','ERROR !!!', MB_OK+MB_ICONERROR);
  end;
  chbActive.Checked:=true;
  stbStatus.Panels[0].Text:='Zpracovavam data... (1/3)';
  with mmbResult.Lines do begin   //z mema se smaze prvni a posledni radka
    Text:=Response;
    Delete(0);
    Delete(Count-1);
  end;
  stbStatus.Panels[0].Text:='Zpracovavam data... (2/3)';
  Response:=mmbResult.Lines.Text;
  p:=pos('  <Stanice>',Response);     //smazou se tagy <Stanice> ...
  while p<>0 do begin
    delete(Response,p,length('  <Stanice>'));
    p:=pos('  <Stanice>',Response);
  end;
  stbStatus.Panels[0].Text:='Zpracovavam data... (3/3)';
  p:=pos('</Stanice>',Response);      //... a tak </Stanice>
  while p<>0 do begin
    delete(Response,p,length('</Stanice>'));
    p:=pos('</Stanice>',Response);
  end;
  mmbResult.Show;
  stbStatus.Panels[0].Text:='Zobrazena odpoved na dotaz: /SeznamStanic';
  mmbResult.Lines.Text:=Response;
end;

procedure TfrmMain.edtServerChange(Sender: TObject);  //pro zmenu adresy serveru
begin
  HTTP.BoundIP:=lblServer.Caption;
  HTTP.Host:=lblServer.Caption;
end;

procedure TfrmMain.spePortChange(Sender: TObject);    //pro zmenu portu serveru
begin
  HTTP.Port:=spePort.Value;
end;

procedure TfrmMain.btnSpojeniClick(Sender: TObject);  //pro vyhledan spojen (/NajdiSpojeni)
var par,Response,hh,mm:string;                        //jeste neni dokoneno formtovn
    p,h,m:integer;
begin
  mmbResult.Hide;           //"pehodm" komponenty
  wbResult.Show;

  h:=speHodin.Value;        //nactu hodiny
  m:=speMinut.Value;
  if (h div 10) = 0 then hh:='0'+inttostr(h) else hh:=inttostr(h);     //v pripade jecnocifern hodnoty upravm na dvoucefernou
  if (m div 10) = 0 then mm:='0'+inttostr(m) else mm:=inttostr(m);
  par:=('?odkud='+edtOdkud.Text+'&kam='+edtKam.Text);                  //pomalu utvm parametry
  if edtPres.Text<>'' then par:=par+'&pres='+edtPres.Text;             //parametr pez uvedu jen kdy je poteba
  par:=par+'&odjezd='+hh+mm+'&prestupy='+inttostr(spePrestupy.Value)+'&spojeni='
   +inttostr(speSpojeni.Value);
  p:=pos(' ',par);      //mezery nahradm znakem "+"
  while p<>0 do begin
    par[p]:='+';
    p:=pos(' ',par);
  end;
  stbStatus.Panels[0].Text:='Nacitam data ze serveru...';
  try
    Response:=HTTP.Get('/NajdiSpojeni'+par);        //nactu data
  except
    Application.MessageBox('Nelze se spojit se serverem !!!','ERROR !!!', MB_OK+MB_ICONERROR);
    exit;
  end;
  stbStatus.Panels[0].Text:='Zpracovavam data...';
  if (Pos('</Chyba>',Response)<>0) and (Length(Response)<333) then begin  //ppadnou chybu obsloum
    Response:=vyrid_chyby(Response);
    mmbResult.Lines.Text:=Response;
    stbStatus.Panels[0].Text:='Chyba v dotazu: '+'/NajdiSpojeni'+par;
//    Application.MessageBox('Neco neni OK !','ERROR !!!', MB_OK+MB_ICONERROR);
    mmbResult.Show;
    wbResult.Hide;
    exit;
  end;
  mmbResult.Lines.Text:=Response;
  mmbResult.Lines.SaveToFile('C:\res.xml');    //jeliko myslm e zobrazen ve WebBrowseru je luxusnj, zadm to...
  wbResult.Navigate('C:\res.xml');
  stbStatus.Panels[0].Text:='Zobrazena odpoved na dotaz: '+'/NajdiSpojeni'+par;
end;

end.
