unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, xmldom, XMLIntf, msxmldom, XMLDoc, StdCtrls, Spin,
  IdBaseComponent, IdComponent, IdTCPServer, IdHTTPServer;

type
  TForm1 = class(TForm)
    chbActive: TCheckBox;
    lblPort: TLabel;
    lblZdroj: TLabel;
    spePort: TSpinEdit;
    edtZdroj: TEdit;
    btnListovat: TButton;
    XMLDoc: TXMLDocument;
    opdZdroj: TOpenDialog;
    HTTPServer: TIdHTTPServer;
    Memo1: TMemo;
    Button1: TButton;
    procedure btnListovatClick(Sender: TObject);
    procedure chbActiveClick(Sender: TObject);
    procedure spePortChange(Sender: TObject);
    procedure edtZdrojChange(Sender: TObject);
    procedure HTTPServerCommandGet(AThread: TIdPeerThread;
      RequestInfo: TIdHTTPRequestInfo; ResponseInfo: TIdHTTPResponseInfo);
    procedure seznam_stanic(AThread: TIdPeerThread ; ResponseInfo: TIdHTTPResponseInfo);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnListovatClick(Sender: TObject);
begin
  if opdZdroj.Execute then edtZdroj.Text:=opdZdroj.FileName;
end;

procedure TForm1.chbActiveClick(Sender: TObject);  //pokud se chce server aktivovat nebo naopak
begin
  try
    HTTPServer.Active:=chbActive.Checked;
  except
    Application.MessageBox('Nelze spustit HTTP server zkontrolujte nastaveni portu !!!','ERROR !!!', MB_OK+MB_ICONERROR);
    chbActive.Checked:=false;
    exit;
  end;
  try
    XMLDoc.Active:=chbActive.Checked;
  except
    Application.MessageBox('Nelze inicializovat XML zkontrolujte zdroj dat !!!','ERROR !!!', MB_OK+MB_ICONERROR);
    HTTPServer.Active:=not chbActive.Checked;
    chbActive.Checked:=false;
  end;
end;

procedure TForm1.spePortChange(Sender: TObject);    //aktualizace portu
begin
  HTTPServer.DefaultPort:=spePort.Value;
end;

procedure TForm1.edtZdrojChange(Sender: TObject);   //aktualizace zdroje dat
begin
  XMLDoc.FileName:=edtZdroj.Text;
end;

procedure TForm1.seznam_stanic(AThread: TIdPeerThread ; ResponseInfo: TIdHTTPResponseInfo); //pri pozadavku /SeznamStanic
var node:IXMLNode;
    nodes:IXMLNodeList;
    i,j:integer;
    s:string;
begin
  XMLDoc.Create(XMLDoc.FileName);
//  node:=XMLDoc.DocumentElement.ChildNodes.FindNode('Stanice');
  nodes:=XMLDoc.DocumentElement.ChildNodes;
//  for i:=1 to node.Collection.Count do {Memo1.Lines.Add(string(node.Collection[i].NodeValue))};  //node.ChildValues[]
//  for i:=1 to node.ChildValues[node.Collection.Count]-1 do Memo1.Lines.Add(string(node.ChildValues[i]));
  for i:=0 to nodes.Count do
   for j:=0 to nodes[i].ChildNodes.Count do
    {Memo1.Lines.Add}s:=(string(nodes[i].ChildNodes[j].NodeValue));

  // XML Proste neumim :-[
end;

procedure TForm1.HTTPServerCommandGet(AThread: TIdPeerThread;   //pri prichozim pozadavku
  RequestInfo: TIdHTTPRequestInfo; ResponseInfo: TIdHTTPResponseInfo);
begin
  if (RequestInfo.Command='GET') and (RequestInfo.Document='/SeznamStanic') then
   seznam_stanic(AThread,ResponseInfo);
end;

procedure TForm1.Button1Click(Sender: TObject); //pro testovani serveru bez klienta 
begin
  seznam_stanic(nil,nil);
end;

end.
